searchNodes=[{"doc":"","ref":"DNS.html","title":"DNS","type":"module"},{"doc":"Queries the DNS server and returns the result. Examples Queries for A records: iex&gt; DNS . query ( &quot;tungdao.com&quot; ) Queries for the MX records: iex&gt; DNS . query ( &quot;tungdao.com&quot; , :mx ) Queries for A records, using OpenDNS: iex&gt; DNS . query ( &quot;tungdao.com&quot; , :a , { &quot;208.67.220.220&quot; , 53 } ) Queries for A records, using OpenDNS, with TCP: iex&gt; DNS . query ( &quot;tungdao.com&quot; , :a , { &quot;208.67.220.220&quot; , 53 } , :tcp )","ref":"DNS.html#query/4","title":"DNS.query/4","type":"function"},{"doc":"Resolves the answer for a DNS query. Examples iex&gt; DNS . resolve ( &quot;tungdao.com&quot; ) { :ok , [ { 1 , 1 , 1 , 1 } ] } iex&gt; DNS . resolve ( &quot;tungdao.com&quot; , :txt ) { :ok , [ [ &#39;v=spf1 a mx ~all&#39; ] ] } iex&gt; DNS . resolve ( &quot;tungdao.com&quot; , :a , { &quot;8.8.8.8&quot; , 53 } ) { :ok , [ { 1 , 1 , 1 , 1 } ] } iex&gt; DNS . resolve ( &quot;tungdao.com&quot; , :a , { &quot;8.8.8.8&quot; , 53 } , :tcp ) { :ok , [ { 1 , 1 , 1 , 1 } ] }","ref":"DNS.html#resolve/4","title":"DNS.resolve/4","type":"function"},{"doc":"Struct definition for serializing and parsing DNS header.","ref":"DNS.Header.html","title":"DNS.Header","type":"module"},{"doc":"Converts a :dns_header record into a DNS.Header .","ref":"DNS.Header.html#from_record/1","title":"DNS.Header.from_record/1","type":"function"},{"doc":"Converts a DNS.Header struct to a :dns_header record.","ref":"DNS.Header.html#to_record/1","title":"DNS.Header.to_record/1","type":"function"},{"doc":"","ref":"DNS.Header.html#t:t/0","title":"DNS.Header.t/0","type":"type"},{"doc":"Struct definition for serializing and parsing DNS query.","ref":"DNS.Query.html","title":"DNS.Query","type":"module"},{"doc":"Converts a :dns_query record into a DNS.Query .","ref":"DNS.Query.html#from_record/1","title":"DNS.Query.from_record/1","type":"function"},{"doc":"Converts a DNS.Query struct to a :dns_query record.","ref":"DNS.Query.html#to_record/1","title":"DNS.Query.to_record/1","type":"function"},{"doc":"","ref":"DNS.Query.html#t:t/0","title":"DNS.Query.t/0","type":"type"},{"doc":"Struct definition for serializing and parsing DNS records.","ref":"DNS.Record.html","title":"DNS.Record","type":"module"},{"doc":"Decodes a binary record into a DNS.Record struct.","ref":"DNS.Record.html#decode/1","title":"DNS.Record.decode/1","type":"function"},{"doc":"Serializes a DNS.Record into its binary representation.","ref":"DNS.Record.html#encode/1","title":"DNS.Record.encode/1","type":"function"},{"doc":"Converts a :dns_rec record into a DNS.Record .","ref":"DNS.Record.html#from_record/1","title":"DNS.Record.from_record/1","type":"function"},{"doc":"Converts a DNS.Record struct to a :dns_rec record.","ref":"DNS.Record.html#to_record/1","title":"DNS.Record.to_record/1","type":"function"},{"doc":"","ref":"DNS.Record.html#t:t/0","title":"DNS.Record.t/0","type":"type"},{"doc":"Struct definition for serializing and parsing DNS resource.","ref":"DNS.Resource.html","title":"DNS.Resource","type":"module"},{"doc":"Converts a :dns_rr or :dns_rr_opt record into a DNS.Resource or DNS.ResourceOpt .","ref":"DNS.Resource.html#from_record/1","title":"DNS.Resource.from_record/1","type":"function"},{"doc":"Converts a DNS.Resource or DNS.ResourceOpt struct to a :dns_rr or :dns_rr_opt record.","ref":"DNS.Resource.html#to_record/1","title":"DNS.Resource.to_record/1","type":"function"},{"doc":"","ref":"DNS.Resource.html#t:t/0","title":"DNS.Resource.t/0","type":"type"},{"doc":"Struct definition for serializing and parsing RFC2671/6891's OPT RR records. The corresponding record in :inet_dns is :dns_rr_opt .","ref":"DNS.ResourceOpt.html","title":"DNS.ResourceOpt","type":"module"},{"doc":"Converts a :dns_rr_opt record into a DNS.ResourceOpt .","ref":"DNS.ResourceOpt.html#from_record/1","title":"DNS.ResourceOpt.from_record/1","type":"function"},{"doc":"Converts a DNS.ResourceOpt struct to a :dns_rr_opt record.","ref":"DNS.ResourceOpt.html#to_record/1","title":"DNS.ResourceOpt.to_record/1","type":"function"},{"doc":"","ref":"DNS.ResourceOpt.html#t:t/0","title":"DNS.ResourceOpt.t/0","type":"type"},{"doc":"DNS server based on GenServer .","ref":"DNS.Server.html","title":"DNS.Server","type":"behaviour"},{"doc":"","ref":"DNS.Server.html#c:handle/2","title":"DNS.Server.handle/2","type":"callback"},{"doc":"Copyright (c) 2016, Tung Dao All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. Neither the name of elixir-dns nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html","title":"License","type":"extras"},{"doc":"DNS DNS library for Elixir. Currently, the package provides: Elixir structs to interface with :inet_dns module DNS.Server behavior DNS client Note: the :inet_dns module is considered internal to Erlang and subject to change. If this happened this library will be updated to accommodate for that, but for now :inet_dns is simple and worked for me.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Make sure you have the Erlang/OTP source files installed, otherwise the compilation will fail with an {:error, :enoent} message. On Ubuntu, this can be done using apt-get install erlang-src . Add :dns to your list of dependencies in mix.exs : def deps do [ { :dns , &quot;~&gt; 2.3.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"DNS client iex&gt; DNS . resolve ( &quot;google.com&quot; ) { :ok , [ { 216 , 58 , 221 , 110 } ] } iex&gt; DNS . resolve ( &quot;notfound.domain&quot; ) { :error , :not_found } iex&gt; DNS . query ( &quot;google.com&quot; ) % DNS.Record { anlist : [ % DNS.Resource { bm : [ ] , class : :in , cnt : 0 , data : { 216 , 58 , 221 , 110 } , domain : &#39;google.com&#39; , func : false , tm : :undefined , ttl : 129 , type : :a } ] , arlist : [ ] , header : % DNS.Header { aa : false , id : 0 , opcode : :query , pr : false , qr : true , ra : true , rcode : 0 , rd : false , tc : false } , nslist : [ ] , qdlist : [ % DNS.Query { class : :in , domain : &#39;google.com&#39; , type : :a } ] } iex&gt; DNS . resolve ( &quot;google.com&quot; , :a , { &quot;8.8.8.8&quot; , 53 } ) ... DNS server defmodule ServerExample do @moduledoc &quot;&quot;&quot; Example implementing DNS.Server behaviour &quot;&quot;&quot; @behaviour DNS.Server use DNS.Server def handle ( record , _cl ) do Logger . info ( fn -&gt; &quot; \#{ inspect ( record ) } &quot; end ) query = hd ( record . qdlist ) result = case query . type do :a -&gt; { 127 , 0 , 0 , 1 } :cname -&gt; &#39;your.domain.com&#39; :txt -&gt; [ &#39;your txt value&#39; ] _ -&gt; nil end resource = % DNS.Resource { domain : query . domain , class : query . class , type : query . type , ttl : 0 , data : result } %{ record | anlist : [ resource ] , header : %{ record . header | qr : true } } end end To run the example server in iex : iex&gt; c &quot;example/test_server.ex&quot; [ ServerExample ] iex&gt; { :ok , server_pid } = ServerExample . start_link 8000 Server listening at 8000 { :ok , # PID &lt; 0 . 180 . 0 &gt; } iex&gt; Process . exit ( server_pid , :normal )","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Copyright (c) 2016 Tung Dao This library is released under the BSD 3-Clause &quot;New&quot; or &quot;Revised&quot; License. See the LICENSE.md file for further details.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]